<template>
  <div>
    <BookingModal
      @closed="showModal = false"
      v-if="showModal"
      :user="user"
      :selected-client="client"
    />
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Client Profile</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item">
                <a>Home</a>
              </li>
              <li class="breadcrumb-item active">Profile</li>
            </ol>
          </div>
        </div>
      </div>
      <!-- /.container-fluid -->
    </section>

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-md-3">
            <!-- Profile Image -->
            <div class="card card-primary card-outline">
              <div class="card-body box-profile">
                <div class="text-center">
                  <img
                    class="profile-client-img img-fluid img-circle"
                    :src="client.image"
                    alt="Client profile picture"
                  />
                </div>

                <h3 class="profile-clientname text-center">
                  {{ client.firstName }}
                </h3>

                <p class="text-muted text-center">Client</p>

                <ul class="list-group list-group-unbordered mb-3">
                  <li class="list-group-item">
                    <b>Trainer</b>
                    <div class="float-right">{{ client.trainerFirstName }}</div>
                  </li>
                  <li class="list-group-item">
                    <b>Email</b>
                    <div class="float-right">{{ client.email }}</div>
                  </li>
                </ul>
              </div>
            </div>
          </div>
          <div class="col-md-9">
            <div class="card">
              <div class="card-header p-2">
                <ul class="nav nav-pills">
                  <li class="nav-item">
                    <a
                      class="nav-link"
                      v-bind:class="{ active: selectedTab === 'INFO' }"
                      @click="selectedTab = 'INFO'"
                      >Info</a
                    >
                  </li>
                  <li
                    v-if="user.role === 'Admin'"
                    class="nav-item"
                    v-bind:class="{ active: selectedTab === 'SETTINGS' }"
                    @click="selectedTab = 'SETTINGS'"
                  >
                    <a class="nav-link">Settings</a>
                  </li>
                  <li
                    v-if="user.role === 'Trainer'"
                    class="nav-item ml-2"
                    @click="showModal = true"
                  >
                    <a class="btn btn-primary">Book session</a>
                  </li>
                </ul>
              </div>
              <div class="card-body">
                <div class="tab-content">
                  <div class="tab-pane active">
                    <form class="p-2">
                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Bio</label>
                          <textarea
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingClient.additionalInfo"
                          ></textarea>
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12 col-md-4">
                          <label>First Name</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingClient.firstName"
                          />
                        </div>
                        <div class="form-group col-sm-12 col-md-4">
                          <label>Middle Name</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingClient.middleName"
                          />
                        </div>
                        <div class="form-group col-sm-12 col-md-4">
                          <label>Surname</label>
                          <input
                            type="text"
                            class="form-control"
                            :disabled="!editing"
                            v-model="editingClient.lastName"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Date of Birth</label>
                          <input
                            type="date"
                            class="form-control"
                            v-model="editingClient.dob"
                            :disabled="!editing"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-12">
                          <label>Phone</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingClient.phone"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-10">
                          <label>Address</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingClient.address"
                          />
                        </div>
                        <div class="form-group col-sm-2">
                          <label>Postal Code</label>
                          <input
                            :disabled="!editing"
                            type="text"
                            class="form-control"
                            v-model="editingClient.postalCode"
                          />
                        </div>
                      </div>

                      <div class="form-row">
                        <div class="form-group col-sm-6">
                          <label>Height</label>
                          <input
                            type="number"
                            :disabled="!editing"
                            v-model="editingClient.height"
                            class="form-control"
                          />
                        </div>
                        <div class="form-group col-sm-6 h-10">
                          <line-chart
                            :chart-data="weightsData"
                            :options="{
                              responsive: true,
                              maintainAspectRatio: false,
                            }"
                          ></line-chart>
                        </div>
                      </div>

                      <hr />

                      <div
                        class="d-flex flex-row-reverse"
                        v-if="user.role === 'Client' || user.role === 'Admin'"
                      >
                        <button
                          type="button"
                          class="btn btn-primary mr-2"
                          :disabled="!editing"
                          @click="editClient"
                        >
                          Update
                        </button>
                        <button
                          type="button"
                          class="btn btn-primary mr-2"
                          @click="editing = !editing"
                        >
                          {{ editing ? "Cancel" : "Edit" }}
                        </button>
                        <button
                          type="button"
                          class="btn btn-primary mr-2"
                          @click="postNewWeight"
                        >
                          Add weight
                        </button>
                      </div>
                    </form>
                  </div>
                  <div
                    class="tab-pane"
                    v-bind:class="{ active: selectedTab === 'SETTINGS' }"
                    v-if="user.role === 'Admin'"
                  >
                    Setting is not ready yet.
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import userController from "../../controllers/user.controller";
import LineChart from "../../plugins/linechart";
import BookingModal from "../../components/Booking/BookingModal";
import swal from "sweetalert2";
export default {
  components: { LineChart, BookingModal },
  name: "ClientProfile",
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
  },
  data() {
    return {
      showModal: false,
      editing: false,
      selectedTab: "INFO",
      editingClient: {},
      weights: [],
      weightsData: {},
    };
  },
  props: ["client"],
  methods: {
    async editClient() {
      try {
        const response = await userController.updateClient(this.editingClient);
        if (response.status === 204) {
          swal.fire({
            icon: "success",
            title: "Profile updated!",
          });
        }

        const newClient = await userController.getClient(this.client.clientId);
        this.client = newClient.data;
        this.$emit("ClientUpdated", newClient.data);
        this.editingClient = { ...newClient.data };
        this.editing = false;
      } catch (e) {
        swal.fire({
          icon: "error",
          title: `Oops... ${e.resposne ? e.resposne.status : ""}`,
          text: "An error occured, please try again!",
        });
      }
    },
    getWeightsData() {
      if (!this.weights) {
        const ret = (this.weightsData = {
          datasets: [{ label: "No data" }],
        });
        return ret;
      }
      let dates = this.weights.map((weight) => {
        return weight.date.split("T")[0];
      });
      let weights = this.weights.map((weight) => {
        return weight.weightAtTime;
      });

      let ret = {};
      ret.labels = [];
      ret.datasets = [];
      let set = {
        label: "weight",
        fill: false,
        backgroundColor: "#0275d8 ",
        borderColor: "#0275d8 ",
        data: [],
      };
      for (let i = 0; i < weights.length; i++) {
        ret.labels.push(dates[i]);
        set.data.push(weights[i]);
      }
      ret.datasets.push(set);

      return ret;
    },
    async postNewWeight() {
      const result = await swal.fire({
        input: "number",
        title: "Enter your weight",
        showCancelButton: true,
        confirmButtonText: "Confirm",
        preConfirm: async (weight) => {
          try {
            await userController.postNewWeight(this.client.clientId, weight);
          } catch (e) {
            swal.fire({
              icon: "error",
              title: "Oops...",
              text: "An unexpected error occured",
            });
          }
        },
        allowOutsideClick: () => !swal.isLoading(),
      });
      if (result.value) {
        swal.fire({
          icon: "success",
          title: "New weight added!",
        });
        try {
          this.weights = await (
            await userController.getClientsWeights(this.client.clientId)
          ).data;
          this.weightsData = this.getWeightsData();
        } catch (e) {
          console.log(e);
        }
      }
    },
  },
  async mounted() {
    this.editingClient = { ...this.client };
    this.editingClient.dob = this.editingClient.dob.split("T")[0];
    this.weights = await (
      await userController.getClientsWeights(this.client.clientId)
    ).data;
    this.weightsData = this.getWeightsData();
  },
};
</script>

<style>
</style>